<?php
namespace PME\Controllers\Parametrizacao;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class TipoCardReportController extends \Zeedhi\Framework\Controller\Report {

    protected $birtStrategy;
    protected $environment;

    public function __construct(ReportService $reportService, $birtStrategy, $environment) {
      $this->birtStrategy  = $birtStrategy;
      $this->environment   = $environment;

      parent::__construct($reportService);
    }

	protected $reportMapping = array (
      'PME00300' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
              "CDFILCENTPME"        => "P_CDFILCENTPME",
              "TIPOCARD"            => "P_CDTIPOCARD",
              "SERVICO"             => "P_CDSERVFILI",
              "NRORG"               => "P_NRORG",
            )
        ),
       'PME00400' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
              "CDFILCENTPME"        => "P_CDFILCENTPME",
              "TIPOCARD"            => "P_CDTIPOCARD",
              "UNIDADE"             => "P_CDFILIAL",
              "NRORG"               => "P_NRORG",
            )
        ),
        'PME00401' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
              "CDFILCENTPME"        => "P_CDFILCENTPME",
              "TIPOCARD"            => "P_CDTIPOCARD",
              "UNIDADE"             => "P_CDFILIAL",
              "NRORG"               => "P_NRORG",
            )
        )
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
      $row = $request->getRow();
      $nrorg = $this->environment->getNrOrg();
      
      if (empty($row['TIPOCARD_RELATORIO'])) $row['TIPOCARD'] = 'T';
      else {
         $tipoCardConcatenado = '_';
         foreach($row['TIPOCARD_RELATORIO'] as $tipocard){
             $tipoCardConcatenado .= $row['CDFILCENTPME'].$tipocard.'_';
         }
         $row['TIPOCARD'] = $tipoCardConcatenado;
      }
      
      
      if (empty($row['SERVICO'])) $row['SERVICO'] = 'T';
      else {
         $servicoConcatenado = '_';
         foreach($row['SERVICO'] as $servico){
             $servicoConcatenado .= $row['CDFILCENTPME'].$servico.'_';
         }
         $row['SERVICO'] = $servicoConcatenado;
      }
      
    if (empty($row['UNIDADE'])) $row['UNIDADE'] = 'T';
    else {
       $unidadeConcatenado = '_';
       foreach($row['UNIDADE'] as $unidade){
           $unidadeConcatenado .= $unidade.'_';
       }
       $row['UNIDADE'] = $unidadeConcatenado;
    }
      
      $row['NRORG'] = $nrorg;
      
      $this->birtStrategy->setReportLocale($this->environment->getLanguage());
      $this->birtStrategy->setReportFormat(strtolower($row['reportFormat']));
    }
}