/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_FORMEMISNF                                               */
/* Tabela : FORMEMISNF                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 18/11/2003 Mariana Costa                                                   */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_FORMEMISNF
BEFORE INSERT OR UPDATE OR DELETE
ON FORMEMISNF FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUFENF := SYSDATE;
   END IF;
   IF UPDATING THEN
      :NEW.DTULTATUFENF := SYSDATE;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('FORMEMISNF', '', 'CDTIPEMNF='||:OLD.CDTIPEMNF||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE FORMEMISNF MODIFY DTULTATUFENF DEFAULT SYSDATE
/
